#ifndef CHEMICAL_REACTOR_HPP_
#define CHEMICAL_REACTOR_HPP_

#include <Block/SpriteBlock/MultiBlock/MultiBlock.hpp>
#include <Block/MachineBlockMixin.hpp>
#include <Machine/MChemicalReactor/MChemicalReactor.hpp>

class ChemicalReactor : public MultiBlock, public MachineBlockMixin<MChemicalReactor>
{
public:
    /*
        #        Chemical Reactor Meta Byte
        +-------+---+---+---+---+---+---+---+---+
        | Bit   | 7 | 6 | 5 | 4 | 3 | 2 | 1 | 0 |
        +-------+---+---+---+---+---+---+---+---+
        | Field |   |   |   |   |   | H | orient|
        +-------+---+---+---+---+---+---+---+---+

        orient
            The orientation of the multi-block structure.
        
        H
            If set, it means the reactor is hot.
    */

    ChemicalReactor(std::string name);

    virtual void getHarvestedStacks(LocalWorld &world, glm::ivec3 pos, std::vector<ItemStack> &stacks) override;
    virtual void onInteract(LocalWorld &world, Player &player, glm::ivec3 pos, Side side, const RGBABytes &collisionKey) override;
    virtual glm::vec3 getLightColor(uint8_t meta) override;
    virtual glm::ivec3 getLightOffset(uint8_t meta) override;
    virtual Sound& getBackgroundSound(uint8_t meta) override;
};

#endif